'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = createTheming;

var _createReactContext = require('create-react-context');

var _createReactContext2 = _interopRequireDefault(_createReactContext);

var _createThemeProvider = require('./createThemeProvider');

var _createThemeProvider2 = _interopRequireDefault(_createThemeProvider);

var _createWithTheme = require('./createWithTheme');

var _createWithTheme2 = _interopRequireDefault(_createWithTheme);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function createTheming(defaultTheme) {
  var ThemeContext = (0, _createReactContext2.default)(defaultTheme);

  var ThemeProvider = (0, _createThemeProvider2.default)(defaultTheme, ThemeContext);
  var withTheme = (0, _createWithTheme2.default)(ThemeProvider, ThemeContext);

  return {
    ThemeProvider: ThemeProvider,
    withTheme: withTheme
  };
}